Merge "ARM64: Add support for aarch64 architecture"
[yardstick.git] / tests / ci / yardstick-verify
1 #!/bin/bash
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 #
12 # Set up the environment and run yardstick test suites.
13 #
14 # Example invocation: yardstick-verify -r 10.4.4.4 suite1.yaml suite2.yaml
15 #
16 # Openstack credentials must be set and the script must be run from its
17 # original location in the yardstick repo.
18 #
19 # This script is intended to be used by the CI pipeline but it may also
20 # be invoked manually.
21 #
22
23 SCRIPT=$0
24 SCRIPT_ARGS=$@
25
26 usage()
27 {
28     cat << EOF
29 usage: $0 options [TEST_SUITE ...]
30
31 If no test suites are given ping.yaml is run.
32
33 OPTIONS:
34    -h      Show this message
35    -r      Http target (example: -r 213.77.62.197/results)
36    -i      Influxdb target (example: -i 127.0.0.1:8086)
37
38            Default target is dump to file ($DISPATCHER_FILE_NAME)
39
40 EOF
41 }
42
43 DISPATCHER_TYPE=file
44 DISPATCHER_FILE_NAME="/tmp/yardstick.out"
45 DISPATCHER_HTTP_TARGET="http://testresults.opnfv.org/test/api/v1/results"
46 DISPATCHER_INFLUXDB_TARGET=
47 UCA_HOST="cloud-images.ubuntu.com"
48 if [ $YARD_IMG_ARCH = "arm64" ]; then
49     export VIVID_IMG_URL="http://${UCA_HOST}/vivid/current/vivid-server-cloudimg-arm64.tar.gz"
50     if ! grep -q "Defaults env_keep += \"VIVID_IMG_URL\"" "/etc/sudoers"; then
51         sudo echo "Defaults env_keep += \"VIVID_IMG_URL\"" >> /etc/sudoers
52     fi
53 fi
54 while getopts "r:i:h" OPTION; do
55     case $OPTION in
56         h)
57             usage
58             exit 0
59             ;;
60         r)
61             DISPATCHER_TYPE=http
62             DISPATCHER_HTTP_TARGET=http://${OPTARG}
63             DISPATCHER_FILE_NAME=
64             ;;
65         i)
66             DISPATCHER_TYPE=influxdb
67             DISPATCHER_INFLUXDB_TARGET=http://${OPTARG}
68             DISPATCHER_FILE_NAME=
69             ;;
70         *)
71             echo "${OPTION} is not a valid argument"
72             exit 1
73             ;;
74     esac
75 done
76
77 shift $[OPTIND - 1]
78 TEST_SUITES=$@
79
80 cleanup()
81 {
82     echo
83     echo "========== Cleanup =========="
84
85     if ! glance image-list; then
86         return
87     fi
88
89     for image in $(glance image-list | grep -e cirros-0.3.3 -e yardstick-trusty-server -e Ubuntu-14.04 \
90         -e yardstick-vivid-kernel | awk '{print $2}'); do
91         echo "Deleting image $image..."
92         glance image-delete $image || true
93     done
94
95     nova flavor-delete yardstick-flavor &> /dev/null || true
96 }
97
98 exitcode=""
99
100 error_exit()
101 {
102     local rc=$?
103
104     if [ -z "$exitcode" ]; then
105         # In case of recursive traps (!?)
106         exitcode=$rc
107     fi
108
109     cleanup
110
111     echo "Exiting with RC=$exitcode"
112
113     exit $exitcode
114 }
115
116 set -o errexit
117 set -o pipefail
118
119 install_yardstick()
120 {
121     echo
122     echo "========== Installing yardstick =========="
123
124     # uninstall previous version
125     pip uninstall -y yardstick || true
126
127     # Install yardstick
128     pip install .
129 }
130
131 install_storperf()
132 {
133     # Install Storper on huawei-pod1
134     if [ "$NODE_NAME" == "huawei-pod1" ]; then
135         echo
136         echo "========== Installing storperf =========="
137
138         if ! yardstick -d plugin install plugin/CI/storperf.yaml; then
139             echo "Install storperf plugin FAILED";
140             exit 1
141         fi
142
143     fi
144 }
145
146 remove_storperf()
147 {
148     # remove Storper from huawei-pod1
149     if [ "$NODE_NAME" == "huawei-pod1" ]; then
150         echo
151         echo "========== Removing storperf =========="
152
153         if ! yardstick -d plugin remove plugin/CI/storperf.yaml; then
154             echo "Remove storperf plugin FAILED";
155             exit 1
156         fi
157
158     fi
159 }
160
161 build_yardstick_image()
162 {
163     echo
164     echo "========== Build yardstick cloud image =========="
165
166     local cmd="sudo $(which yardstick-img-modify) $(pwd)/tools/ubuntu-server-cloudimg-modify.sh"
167
168     # Build the image. Retry once if the build fails.
169     $cmd || $cmd
170
171     if [ ! -f $QCOW_IMAGE ]; then
172         echo "Failed building QCOW image"
173         exit 1
174     fi
175 }
176
177 create_nova_flavor()
178 {
179     if ! nova flavor-list | grep -q yardstick-flavor; then
180         echo
181         echo "========== Create nova flavor =========="
182         # Create the nova flavor used by some sample test cases
183         nova flavor-create yardstick-flavor 100 512 3 1
184         # DPDK-enabled OVS requires guest memory to be backed by large pages
185         if [[ "$DEPLOY_SCENARIO" == *"-ovs-"* ]]; then
186             nova flavor-key yardstick-flavor set hw:mem_page_size=large
187         fi
188     fi
189 }
190
191 load_cirros_image()
192 {
193     echo
194     echo "========== Loading cirros cloud image =========="
195
196     local image_file=/home/opnfv/images/cirros-0.3.3-x86_64-disk.img
197
198     output=$(glance image-create \
199         --name  cirros-0.3.3 \
200         --disk-format qcow2 \
201         --container-format bare \
202         --file $image_file)
203     echo "$output"
204
205     CIRROS_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
206     if [ -z "$CIRROS_IMAGE_ID" ]; then
207         echo 'Failed uploading cirros image to cloud'.
208         exit 1
209     fi
210
211     echo "Cirros image id: $CIRROS_IMAGE_ID"
212 }
213
214 load_ubuntu_image()
215 {
216     echo
217     echo "========== Loading ubuntu cloud image =========="
218
219     local ubuntu_image_file=/home/opnfv/images/trusty-server-cloudimg-amd64-disk1.img
220
221     output=$(glance image-create \
222         --name Ubuntu-14.04 \
223         --disk-format qcow2 \
224         --container-format bare \
225         --file $ubuntu_image_file)
226     echo "$output"
227
228     UBUNTU_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
229
230     if [ -z "$UBUNTU_IMAGE_ID" ]; then
231         echo 'Failed uploading UBUNTU image to cloud'.
232         exit 1
233     fi
234
235     echo "Ubuntu image id: $UBUNTU_IMAGE_ID"
236 }
237
238 load_yardstick_image()
239 {
240     echo
241     echo "========== Loading yardstick cloud image =========="
242     EXTRA_PARAMS=""
243     if [ $YARD_IMG_ARCH = "arm64" ]; then
244         VIVID_IMAGE="/tmp/vivid-server-cloudimg-arm64.tar.gz"
245         VIVID_KERNEL="/tmp/vivid-server-cloudimg-arm64-vmlinuz-generic"
246         cd /tmp
247         if [ ! -f $VIVID_IMAGE ]; then
248             wget $VIVID_IMG_URL
249         fi
250         if [ ! -f $VIVID_KERNEL ]; then
251             tar zxf $VIVID_IMAGE $(basename $VIVID_KERNEL)
252         fi
253         create_vivid_kernel=$(glance --os-image-api-version 1 image-create \
254                 --name yardstick-vivid-kernel \
255                 --is-public true --disk-format qcow2 \
256                 --container-format bare \
257                 --file $VIVID_KERNEL)
258
259         GLANCE_KERNEL_ID=$(echo "$create_vivid_kernel" | grep " id " | awk '{print $(NF-1)}')
260         if [ -z "$GLANCE_KERNEL_ID" ]; then
261             echo 'Failed uploading kernel to cloud'.
262             exit 1
263         fi
264
265         command_line="root=/dev/vdb1 console=tty0 console=ttyS0 console=ttyAMA0 rw"
266
267         EXTRA_PARAMS="--property kernel_id=$GLANCE_KERNEL_ID --property os_command_line=\"$command_line\""
268
269         rm -f $VIVID_KERNEL $VIVID_IMAGE
270         cd $YARDSTICK_REPO_DIR
271     fi
272     output=$(eval glance --os-image-api-version 1 image-create \
273         --name yardstick-trusty-server \
274         --is-public true --disk-format qcow2 \
275         --container-format bare \
276         $EXTRA_PARAMS \
277         --file $QCOW_IMAGE)
278
279     echo "$output"
280
281     GLANCE_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
282
283     if [ -z "$GLANCE_IMAGE_ID" ]; then
284         echo 'Failed uploading image to cloud'.
285         exit 1
286     fi
287
288     sudo rm -f $QCOW_IMAGE
289
290     echo "Glance image id: $GLANCE_IMAGE_ID"
291 }
292
293 run_test()
294 {
295     echo
296     echo "========== Running yardstick test suites =========="
297
298     mkdir -p /etc/yardstick
299
300     cat << EOF >> /etc/yardstick/yardstick.conf
301 [DEFAULT]
302 debug = True
303 dispatcher = ${DISPATCHER_TYPE}
304
305 [dispatcher_file]
306 file_name = ${DISPATCHER_FILE_NAME}
307
308 [dispatcher_http]
309 timeout = 5
310 target = ${DISPATCHER_HTTP_TARGET}
311
312 [dispatcher_influxdb]
313 timeout = 5
314 target = ${DISPATCHER_INFLUXDB_TARGET}
315 db_name = yardstick
316 username = opnfv
317 password = 0pnfv2015
318 EOF
319
320     local failed=0
321     local start_date
322     local stop_date
323
324     if [ ${#SUITE_FILES[@]} -gt 0 ]; then
325
326         start_date=$(date '+%Y-%m-%d %H:%M:%S')
327         for suite in ${SUITE_FILES[*]}; do
328
329             echo "---------------------------"
330             echo "Running test suite: $suite"
331             echo "---------------------------"
332             if ! yardstick task start --suite $suite; then
333                  echo "test suite $suite FAILED";
334
335                 # Mark the test suite failed but continue
336                 # running the remaining test suites.
337                 (( failed++ ))
338             fi
339             if [ ${DISPATCHER_TYPE} = file ]; then
340                 echo "---------------------------"
341                 echo "Dump test suite $suite result"
342                 echo "---------------------------"
343                 if [ -f ${DISPATCHER_FILE_NAME} ]; then
344                     cat ${DISPATCHER_FILE_NAME}
345                 else
346                     echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
347                 fi
348             fi
349         done
350         stop_date=$(date '+%Y-%m-%d %H:%M:%S')
351
352
353
354         local scenario_status="SUCCESS"
355
356         if [ $failed -gt 0 ]; then
357             scenario_status="FAILED"
358         fi
359         curl -i -H 'content-type: application/json' -X POST -d \
360             "{\"project_name\": \"yardstick\",
361               \"case_name\": \"scenario_status\",
362               \"pod_name\":\"${NODE_NAME}\",
363               \"installer\":\"${INSTALLER_TYPE}\",
364               \"version\":\"${YARDSTICK_BRANCH}\",
365               \"scenario\":\"${DEPLOY_SCENARIO}\",
366               \"description\": \"yardstick ci scenario status\",
367               \"start_date\":\"${start_date}\",
368               \"criteria\":\"${scenario_status}\",
369               \"stop_date\":\"${stop_date}\",
370               \"details\":\"\"}" \
371               ${DISPATCHER_HTTP_TARGET}
372
373         if [ $failed -gt 0 ]; then
374             echo "---------------------------"
375             echo "$failed out of ${SUITE_FILES[*]} test suites FAILED"
376             echo "---------------------------"
377             exit 1
378         fi
379
380     else
381
382         echo "---------------------------"
383         echo "Running samples/ping.yaml  "
384         echo "---------------------------"
385
386         if ! yardstick task start samples/ping.yaml; then
387             echo "Yardstick test FAILED"
388             exit 1
389         fi
390
391         if [ ${DISPATCHER_TYPE} = file ]; then
392             echo "---------------------------"
393             echo "Dump samples/ping.yaml test result"
394             echo "---------------------------"
395             if [ -f ${DISPATCHER_FILE_NAME} ]; then
396                 cat ${DISPATCHER_FILE_NAME}
397             else
398                 echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
399             fi
400         fi
401
402     fi
403
404 }
405
406 main()
407 {
408     GITROOT=$(cd $(dirname $0) && git rev-parse --show-toplevel)
409
410     cd $GITROOT
411
412     export YARDSTICK_VERSION=$(git rev-parse HEAD)
413
414     SUITE_FILES=()
415
416     # find the test suite files
417     for suite in $TEST_SUITES; do
418         if [ -f $suite ]; then
419             SUITE_FILES+=($suite)
420         else
421             tsdir=$GITROOT/tests/opnfv/test_suites
422             if [ ! -f $tsdir/$suite ]; then
423                 echo "Test suite \"$suite\" does not exist"
424                 exit 1
425             fi
426             SUITE_FILES+=($tsdir/$suite)
427         fi
428     done
429
430     echo
431     echo "========== Running Yardstick CI with following parameters =========="
432     echo "Script options: ${SCRIPT} $SCRIPT_ARGS"
433     echo "Dispatcher: ${DISPATCHER_TYPE} ${DISPATCHER_FILE_NAME}"
434     echo "YARDSTICK_VERSION: ${YARDSTICK_VERSION}"
435     echo "Number of test suites: ${#SUITE_FILES[@]}"
436     for suite in ${SUITE_FILES[*]}; do
437         echo "     $suite"
438     done
439     echo
440
441     # check if some necessary variables is set
442     if [ -z "$OS_AUTH_URL" ]; then
443         echo "OS_AUTH_URL is unset or empty"
444         exit 1
445     fi
446
447     echo "OS_AUTH_URL is $OS_AUTH_URL"
448     echo
449
450     # check OpenStack services
451     echo "Checking OpenStack services:"
452     for cmd in "glance image-list" "nova list" "heat stack-list"; do
453         echo "  checking ${cmd/%\ */} ..."
454         if ! $cmd >/dev/null; then
455             echo "error: command \"$cmd\" failed"
456             exit 1
457         fi
458     done
459
460     echo
461     echo "Checking for External network:"
462     for net in $(neutron net-list --router:external True -c name -f value); do
463         echo "  external network: $net"
464     done
465
466     # install yardstick
467     install_yardstick
468
469     cleanup
470
471     trap "error_exit" EXIT SIGTERM
472
473     QCOW_IMAGE="/tmp/workspace/yardstick/yardstick-trusty-server.img"
474
475     build_yardstick_image
476     load_yardstick_image
477     if [ $YARD_IMG_ARCH = "arm64" ]; then
478         sed -i 's/image: cirros-0.3.3/image: TestVM/g' tests/opnfv/test_cases/opnfv_yardstick_tc002.yaml \
479         samples/ping.yaml
480         #We have overlapping IP with the real network
481         for filename in tests/opnfv/test_cases/*; do
482             sed -i "s/cidr: '10.0.1.0\/24'/cidr: '10.3.1.0\/24'/g" $filename
483         done
484     else
485         load_cirros_image
486         load_ubuntu_image
487     fi
488     create_nova_flavor
489     install_storperf
490     run_test
491     remove_storperf
492 }
493
494 main